/*
X105DI.c: The X105DI program is input for X105 8 channels DI/O board.
         (single channel programmable)

Compiler: MSC 6.0
          MSVC 1.52

Compile mode: large

Project: X105DI.c
         ..\..\Lib\7188xcl.lib
         ..\..\lib\Xboard\X105.lib
         
Hardware: 7188XC + X105
X105: 8 channels.
      Each channel can be program to DI/DO.
      
Note:  Please remove the external signal which connects to X105,
       before changing the status of channels from DI to DO mode

[02/Aug/2002]
[20/July/2005] by Liam
*/

#include <conio.h>
#include "..\..\lib\7188xc.h"
#include "..\..\lib\Xboard\X105.h"

void main(void)
{
    int iAction, iStatus, iInChannel, iDIValue, iRet, quit;
    char buf[100];
    
    InitLib();
    X105_Init(_DI_);    //Initialize the X105, and set all channels to DI
    
    Print("\r\n");
    Print("*****************************************\n\r");
    Print("|     Demo program for 7188XC + X105    |\n\r");
    Print("|                                       |\n\r");
    Print("|            [20/July/2005]             |\n\r");
    Print("*****************************************\n\r");

    while(iAction!=3)
    {
        iAction=0;
        quit=0;
        
        Puts("\n\r");
        Puts("1) Read DI (all channels)\n\r");
        Puts("2) Read DI (one channel)\n\r");
        Puts("\n\r");
        Puts("3) Quits demo program\n\r\n\r");
        Puts("Choose an option and press [Enter]:");
        LineInput(buf, 99);
        sscanf(buf, "%d", &iAction);
        Puts("\n\r");

        switch(iAction)
        {
            /* Read DI (all channels) */
            case 1:
                iDIValue=X105_Read_All_DI();
                
                Print("Input value=> 0x%02x\r\n\r\n", iDIValue);
            break;
            /* Read DI (one channels) */
            case 2:
                Print("Please select inport channel(0~7): ");
                LineInput(buf, 99);
                sscanf(buf, "%d", &iInChannel);
                
                if(iInChannel>7)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iDIValue=X105_Read_One_DI(iInChannel);
                
                if(iDIValue)
                    Print("Channel %d ==> OFF\r\n\r\n", iInChannel);
                else
                    Print("Channel %d ==> ON\r\n\r\n", iInChannel);                    
            break;
                        
            case 3:
            default:
                quit=1;
            break;
            
        }
        if(!quit)
        {
            Puts("Press any key to continue...\r\n");
            Getch();
        }
    }
}
