/*
X608Demo.c: Demo program for X608

Compiler: MSC 6.0
          MSVC 1.52

Compile mode: large

Project: X608.c
         ..\..\lib\7188xcl.lib
         ..\..\lib\XBoard\X608.lib

Hardware: 7188XC + X608

[June/20/2002] by David
[May/20/2005] by Liam
[11/July/2005] by Liam

/********************* M5M51008 **********************************
 * Funtion:   512K Byte SRAM (1k Block,one Block is 128 Byte)    *
 *                                                               *
 * Date:       2002/6/20                                         *
 * ControlPin: /OE ---> /RD                                      *
 *             /S1 ---> /CS                                      *
 *              S2 ---> DIO14                                    *
 *              /W ---> /WR                                      *
 *                                                               *
 * 							offset 0~127 bytes                   *
 *	             0   1  2                   125 126 127 byte	 *
 *     	       ----+---+---+---------------+---+---+---+         *
 * Block 0     |   |   |   |               |   |   |   |         *
 *		       |---+---+---+ ------------- +---+---+---+         *
 * Block 1     |   |   |   |               |   |   |   |         *
 *             |---+---+---+ ------------- +---+---+---+         *
 *			     :                                   :           *
 *			     :                                   :           *
 *			     :                                   :           *
 *			     :                                   :           *
 *			     :                                   :           *
 *     	       ----+---+---+---------------+---+---+---+         *
 * Block 4092  |   |   |   |               |   |   |   |         *
 *		       |---+---+---+ ------------- +---+---+---+         *
 * Block 4093  |   |   |   |               |   |   |   |         *
 *             |---+---+---+ ------------- +---+---+---+         *
 * Block 4094  |   |   |   |               |   |   |   |         *
 *		       |---+---+---+ ------------- +---+---+---+         *
 * Block 4095  |   |   |   |               |   |   |   |         *
 *             |---+---+---+ ------------- +---+---+---+         *
 *                                                               *
 * **************************************************************/

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "..\..\lib\7188xc.h"
#include "..\..\lib\Xboard\X608.h"

void main(void)
{
	uchar Wdata[100];
	uchar Rdata[100];
	int WData,RData,iRet,iAction,sTemp,block,offset;
	int len,i,j;
	unsigned int addr=0;
	char buf[100];
	
    InitLib();
	X608_Init();    //Initialize the X608

	Puts("\r\n");
	Puts("*******************************************\r\n");
	Puts("|      Demo program for 7188XC + X608     |\r\n");
	Puts("|                      	                |\r\n");
	Puts("|		    [28,Juiy,2002] by DAVID         |\r\n");
	Puts("*******************************************\r\n");
	
	while(iAction!=5)
	{
		Puts("\r\n");
		Puts("1) Use [Absolute address] method to test 1 byte of 512K SRAM\r\n");
		Puts("2) Use [Block ,Offset] method to test 1 byte of 512K SRAM\r\n");
		Puts("3) Use [Absolute address] method to test N byte of 512K SRAM\r\n");
		Puts("4) Use [Block ,Offset] method to test N byte of 512K SRAM\r\n");
		Puts("\n\r");
		Puts("5) Quits demo program\r\n\r\n");
		Puts("Please select (1~5):");
		LineInput(buf, 99);
		sscanf(buf, "%d", &iAction);
		Puts("\r\n");
		/************************************************************/
		/* Use [Absolute address] method to test 1 byte of 512K SRAM*/
		/************************************************************/
		if(iAction==1)
		{
			X608_Init();
			Print("Please input a absolute addrss ( 0-65535 ) to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%u", &addr);
			Print("Please input data( 0-255) to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%d", &Wdata[0]);
			X608_WriteFn(addr, 1, Wdata);
			X608_ReadFn(addr, 1, Rdata);
			Print("\r\nAddr[%5u]: Write data = %3d, Read data = %3d.", addr, Wdata[0], Rdata[0]);
		}
		/**********************************************************/
		/* Use [Block ,Offset] method to test 1 byte of 512K SRAM */
		/**********************************************************/
		if(iAction==2)
		{
			X608_Init();
			Print("Please select block ( 0-1023 ) to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%d", &block);
			Print("Please select offset( 0-127 ) to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%d", &offset);
			Print("Please input data( 0-255 ) to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%d", &WData);
			X608_Write(block, offset, WData);
			RData = X608_Read(block, offset);
			Print("\r\n[%4d,%3d]: Write data = %3d ,Read data = %3d.", block, offset, WData, RData);
		}
		/************************************************************/
		/* Use [Absolute address] method to test N byte of 512K SRAM*/
		/************************************************************/
		if(iAction==3)
		{
			X608_Init();
			Print("Please input a absolute addrss ( 0-65535 ) to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%u", &addr);
			Print("Please input data( 0-255 ) to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%d", Wdata);
			Print("Please input N(0-65535) byte to write SRAM:");
			LineInput(buf, 99);
			sscanf(buf, "%d", &len);
			for(i=0; i<len; i++) Wdata[i]=Wdata[0];
			X608_WriteFn(addr, len, Wdata);
			X608_ReadFn(addr, len, Rdata);
			for(i=0; i<len; i++)
            {
				Print("\n\r Addr[%5u]: Write data = %3d ,Read data = %3d.", i+addr, Wdata[i], Rdata[i]);
				if (Wdata[i]!=Rdata[i])
                {
					Getch();
				}
		   	}
		}
		/**********************************************************/
		/* Use [Block ,Offset] method to test N byte of 512K SRAM */
		/**********************************************************/
		if(iAction==4)
		{
			X608_Init();
		    Print("Please select block (0-1023) to write SRAM:");
		    LineInput(buf, 99);
		    sscanf(buf,"%d", &block);
		    Print("Please select offset(0-127) to write SRAM:");
		    LineInput(buf, 99);
		    sscanf(buf, "%d", &offset);
		    Print("Please input data(0-255) to write SRAM:");
		    LineInput(buf, 99);
		    sscanf(buf, "%d", &WData);
		    Print("Please input N(0-100) byte to write SRAM:");
		    LineInput(buf, 99);
		    sscanf(buf, "%d", &len);
		    for (i=0; i<len; i++)
            {
			    X608_Write(block, offset+i, WData);
			    RData = X608_Read(block, offset+i);
			    Print("\r\n[%4d,%3d]: Write data = %3d, Read data = %3d.", block, offset+i, WData, RData);
		    }
		}
		/* Quit */
		if(iAction==5)
			break;
		Puts("\r\nPress [Enter] to continue...");
		LineInput(buf, 99);
		sscanf(buf, "%d", &len);
	}
}


